<?php
/*
Plugin Name: 扩展字段
Version: 0.1
Plugin URL:
Description: 添加额外字段
Author: Syan
Author URL: http://pinwen.org
*/

!defined('EMLOG_ROOT') && exit('access deined!');

function syanCustomFields_css(){
?>
		<style type='text/css'>
		#syanCustomFields{
			width: 845px;
			min-height:100px;
			margin-top:10px;
			display:none;
			border-top: 1px solid #eee;
		}
		.syanCustomFields_table{
			width: 100%;
		}
		.syanCustomFields_table td{
			padding: 10px 5px;
			font-size: .92857em;
			border-bottom: 1px solid #eee;
			vertical-align: top;
			word-break: break-all;
		}
		.syanCustomFields_table .fieldNames{
			border:1px solid #eee;
			line-height: 100%;
			padding:3px 4px;
			outline: medium none;
		}
		.syanCustomFields_table .fieldTypes{
			border:1px solid #eee;
			outline:none;
		}
		.syanCustomFields_table .fieldValues{
			width: 92%;
			padding:5px;
			border:1px solid #eee;
			outline:none;
		}
		#syanCustomFields tbody {
			display: table-row-group;
			vertical-align: middle;
			border-color: inherit;
		}
		#syanCustomFields button.syanCustomFields_add{
			width: 100%;
			margin: 10px 0;
		}
		</style>
		<script type="text/javascript">
		function syanCustomFields_toggle(id){
	    	var sc = $("#"+id).is(":hidden");
	    	if(sc){
	    		$(".syanCustomFields_button").css({color:"#68aee1"});
	    		$("#"+id).show();
	    	}else{
	    		$(".syanCustomFields_button").css({color:"#000"});
	    		$("#"+id).hide();
	    	}
	    }
	    </script>
<?php
}

addAction('adm_head', 'syanCustomFields_css');

function syanCustomFields_add_button(){
	echo "<span class='show_advset syanCustomFields_button' onclick=\"syanCustomFields_toggle('syanCustomFields');\">扩展字段</span>";
	$gid = intval($_GET['gid']);
	$DB = Database::getInstance();
	$contentFieldsRes = $DB->query("SELECT * FROM " . DB_PREFIX . "fields WHERE gid=$gid");
	$contentFields = array();
	while ($rows = $DB->fetch_array($contentFieldsRes)) {
		$contentFields[] = $rows;
	}
	if(empty($contentFields)){
?>
<script>
$(document).ready(function () {
			$("#FrameUpload").before('<div id="syanCustomFields"><table class="syanCustomFields_table"><colgroup><col width="25%"><col width="10%"><col width="55%"><col width="10%"></colgroup><tbody><tr><td><input type="text" name="fieldNames[]" placeholder="字段名称" title="字段名称" class="fieldNames"></td><td><select name="fieldTypes[]" class="fieldTypes" title="字段类型"><option value="str">字符</option><option value="int">整数</option><option value="float">小数</option></select></td><td><textarea name="fieldValues[]" placeholder="字段值" rows="3" class="fieldValues" title="字段值"></textarea></td><td><button type="button" class="syanCustomFields_del">删除</button></td></tr></tbody></table><button type="button" class="syanCustomFields_add">添加字段</button></div><div style="clear:both;"></div>');
			function attachDeleteEvent (el) {
		        $('button.syanCustomFields_del', el).click(function () {
		            if (confirm('确认要删除此字段吗?')) {
		                $(this).parents('tr').fadeOut(function () {
		                    $(this).remove();
		                });
		            }
		        });
		    }
		    $('#syanCustomFields table tbody tr').each(function () {
		        attachDeleteEvent(this);
		    });
		    $('#syanCustomFields button.syanCustomFields_add').click(function () {
		        var html = '<tr><td><input type="text" name="fieldNames[]" placeholder="字段名称" title="字段名称" class="fieldNames"></td>'
		                + '<td><select name="fieldTypes[]" class="fieldTypes" title="字段类型">'
		                + '<option value="str">字符</option>'
		                + '<option value="int">整数</option>'
		                + '<option value="float">小数</option>'
		                + '</select></td>'
		                + '<td><textarea name="fieldValues[]" placeholder="字段值" rows="3" class="fieldValues" title="字段值"></textarea></td>'
		                + '<td><button type="button" class="syanCustomFields_del">删除</button></td></tr>',
		            el = $(html).appendTo('#syanCustomFields table tbody');

		        attachDeleteEvent(el);
		    });
});
</script>
<?php

	}else{
		//var_dump($contentFields);
?>
<script>
$(document).ready(function () {
			var syanhtml = ''<?php foreach ($contentFields as $key => $value) : ?>
								+'<tr><td><input type="text" name="fieldNames[]" value="<?php echo $value['name']; ?>" placeholder="字段名称" title="字段名称" class="fieldNames"></td><td><select name="fieldTypes[]" class="fieldTypes" title="字段类型"><option value="str" <?php echo $value['type']=='str'? 'selected="selected"':''; ?>>字符</option><option value="int" <?php echo $value['type']=='int'? 'selected="selected"':''; ?>>整数</option><option value="float" <?php echo $value['type']=='float'? 'selected="selected"':''; ?>>小数</option></select></td><td><textarea name="fieldValues[]" placeholder="字段值" rows="3" class="fieldValues" title="字段值"><?php switch($value['type']){case 'str': echo $value['str_value'];break; case 'int': echo $value['int_value'];break; default: echo $value['float_value'];break;}; ?></textarea></td><td><button type="button" class="syanCustomFields_del">删除</button></td></tr>'
							<?php endforeach; ?>
			$("#FrameUpload").before('<div id="syanCustomFields"><table class="syanCustomFields_table"><colgroup><col width="25%"><col width="10%"><col width="55%"><col width="10%"></colgroup><tbody>'+ syanhtml +'</tbody></table><button type="button" class="syanCustomFields_add">添加字段</button></div><div style="clear:both;"></div>');
			function attachDeleteEvent (el) {
		        $('button.syanCustomFields_del', el).click(function () {
		            if (confirm('确认要删除此字段吗?')) {
		                $(this).parents('tr').fadeOut(function () {
		                    $(this).remove();
		                });
		            }
		        });
		    }
		    $('#syanCustomFields table tbody tr').each(function () {
		        attachDeleteEvent(this);
		    });
		    $('#syanCustomFields button.syanCustomFields_add').click(function () {
		        var html = '<tr><td><input type="text" name="fieldNames[]" placeholder="字段名称" title="字段名称" class="fieldNames"></td>'
		                + '<td><select name="fieldTypes[]" class="fieldTypes" title="字段类型">'
		                + '<option value="str">字符</option>'
		                + '<option value="int">整数</option>'
		                + '<option value="float">小数</option>'
		                + '</select></td>'
		                + '<td><textarea name="fieldValues[]" placeholder="字段值" rows="3" class="fieldValues" title="字段值"></textarea></td>'
		                + '<td><button type="button" class="syanCustomFields_del">删除</button></td></tr>',
		            el = $(html).appendTo('#syanCustomFields table tbody');

		        attachDeleteEvent(el);
		    });
});
</script>
<?php
	}

}

addAction('adm_writelog_head', 'syanCustomFields_add_button');

function syanCustomFields_save($blogid){
	$DB = Database::getInstance();
	$contentFieldsRes = $DB->query("SELECT name FROM " . DB_PREFIX . "fields WHERE gid=$blogid");
	$contentFields = array();
	while ($rows = $DB->fetch_array($contentFieldsRes)) {
		$contentFields[] = $rows;
	}
	$exists = array_flip(syanCustomFields_arrayFlatten($contentFields, 'name'));

	$fields = syanCustomFields_getFields();
	foreach ($fields as $name => $value) {
        $type = 'str';

        if (is_array($value) && 2 == count($value)) {
            $type = $value[0];
            $value = $value[1];
        }

        if (!syanCustomFields_checkFieldName($name)) {
            continue;
        }

        if (isset($exists[$name])) {
            unset($exists[$name]);
        }

        syanCustomFields_setField($name, $type, $value, $blogid);
    }

    foreach ($exists as $name => $value) {
        $DB->query("DELETE FROM " . DB_PREFIX . "fields WHERE gid=$blogid AND name='$name'");
    }

	
}
addAction('save_log', 'syanCustomFields_save');

function syanCustomFields_checkFieldName($name){
	return preg_match("/^[_a-z][_a-z0-9]*$/i", $name);
}

function syanCustomFields_setField($name, $type, $value, $blogid){
	if (empty($name) || !syanCustomFields_checkFieldName($name) 
        || !in_array($type, array('str', 'int', 'float'))) {
        return false;
    }
    $DB = Database::getInstance();
    $res = $DB->query("SELECT gid FROM ".DB_PREFIX."fields WHERE gid = $blogid AND name='$name'");
    $exist = $DB->fetch_row($res);
    $str_value = 'str' == $type ? $value : NULL;
    $int_value = 'int' == $type ? intval($value) : 0;
    $float_value = 'float' == $type ? floatval($value) : 0;
    if(empty($exist)){
    	return $DB->query("INSERT INTO ".DB_PREFIX."fields (gid,name,type,str_value,int_value,float_value) values($blogid,'$name','$type', '$str_value',$int_value,$float_value)");
    }else{
    	return $DB->query("UPDATE ".DB_PREFIX."fields SET type='$type' , str_value='$str_value' , int_value=$int_value , float_value=$float_value WHERE gid=$blogid AND name='$name'");
    }
}

function syanCustomFields_getFields(){
	$fields = array();
    $fieldNames = array_map('trim', array_map('addslashes', $_POST['fieldNames']));
    if (!empty($fieldNames)) {
        $data = array(
            'fieldNames'    =>  array_map('trim', array_map('addslashes', $_POST['fieldNames'])),
            'fieldTypes'    =>  array_map('addslashes', $_POST['fieldTypes']),
            'fieldValues'   =>  array_map('addslashes', $_POST['fieldValues'])
        );
        foreach ($data['fieldNames'] as $key => $val) {
            if (empty($val)) {
                continue;
            }

            $fields[$val] = array($data['fieldTypes'][$key], $data['fieldValues'][$key]);
        }
    }
    return $fields;
}

function syanCustomFields_arrayFlatten(array $value, $key){
	$result = array();
    if ($value) {
        foreach ($value as $inval) {
            if (is_array($inval) && isset($inval[$key])) {
                $result[] = $inval[$key];
            } else {
                break;
            }
        }
    }
    return $result;
}
function getCustomField($gid, $name, $default = ''){
	$DB = Database::getInstance();
	$row = $DB->fetch_array($DB->query("SELECT * FROM " . DB_PREFIX . "fields WHERE gid=$gid AND name='$name'"));
	if(! $row)return $default;
	switch ($row['type']) {
		case 'str':
			return $row['str_value'];
			break;
		case 'int':
			return $row['int_value'];
		default:
			return $row['float_value'];
			break;
	}
}
function getCustomFields($gid){
	$DB = Database::getInstance();
	$res = $DB->query("SELECT * FROM " . DB_PREFIX . "fields WHERE gid=$gid");
	$fields = array();
	while ($rows = $DB->fetch_array($res)) {
		$value = NULL;
		switch ($rows['type']) {
			case 'str':
				$value = $rows['str_value'];
				break;
			case 'int':
				$value = $rows['int_value'];
				break;
			default:
				$value = $rows['float_value'];
				break;
		}
		$fields[$rows['name']] = $value;
	}
	return $fields;
}
?>